"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
/* eslint no-param-reassign: 0 */

var getNormalizedPage = function getNormalizedPage(page, pageStartIndex) {
  var offset = Math.abs(1 - pageStartIndex);
  return page + offset;
};

var endIndex = function endIndex(page, sizePerPage, pageStartIndex) {
  return getNormalizedPage(page, pageStartIndex) * sizePerPage - 1;
};

var startIndex = function startIndex(end, sizePerPage) {
  return end - (sizePerPage - 1);
};

var alignPage = exports.alignPage = function alignPage(store, pageStartIndex, sizePerPage) {
  var end = endIndex(store.page, sizePerPage, pageStartIndex);
  var dataSize = store.data.length;

  if (end - 1 > dataSize) {
    return pageStartIndex;
  }
  return store.page;
};

var getByCurrPage = exports.getByCurrPage = function getByCurrPage(store, pageStartIndex) {
  var dataSize = store.data.length;
  if (!dataSize) return [];
  var end = endIndex(store.page, store.sizePerPage, pageStartIndex);
  var start = startIndex(end, store.sizePerPage);

  var result = [];
  for (var i = start; i <= end; i += 1) {
    result.push(store.data[i]);
    if (i + 1 === dataSize) break;
  }
  return result;
};